#!/bin/sh

# Glossary format is
# 
# Name  Type  Stack relation  Description
# 
# Type is encoded in four letters (CTIS), where
# 
# C = Class
# 	H = HLL (colon definition)
# 	K = Kernel (threaded, but coded in assembly)
# 	P = Primitive (assembly language)
# 
# T = Type
# 	: = threaded
# 	> = deferred
# 	A = array
# 	C = constant
# 	M = machine code
# 	V = variable
# 
# I = Immediate
# 
# S = Scanning (code moves >in)

grep '^;; ' sol.s11 | sed -e 's/^.. //'  >__tmp
grep '^\\D ' kernel.scr | sed -e 's/^.. //'  >>__tmp
sort <__tmp | awk '
BEGIN	{
	IFS=" "
	}
	{
	sr=substr($0, index($0, "( "))
	sr=substr(sr, 0, index(sr,")"))
	de=substr($0, index($0, " -- ")+4)
	fl=substr($0, index($0, " ) "))
	fl=substr(fl, 3, 5)
	printf "%-15s%s  %s %s\n", $1, fl, sr, de
	}
' >Glossary
rm -f __tmp
